<template>
  <div>
    <div>
      <el-breadcrumb separator-class="el-icon-arrow-right">
        <el-breadcrumb-item :to="{ path: '/home' }">首页</el-breadcrumb-item>
        <el-breadcrumb-item>用户管理</el-breadcrumb-item>
        <el-breadcrumb-item>用户列表</el-breadcrumb-item>
      </el-breadcrumb>
    </div>
    <!-- 卡片视图 -->
    <el-card>
        <el-row :gutter="20">
            <el-col :span="10">
                <el-input 
                    placeholder="请输入内容"
                    v-model="queryInfo.query"
                    clearable
                    @change="getUserList"
                    @clear="getUserList"
                >
                    <el-button 
                        slot="append" 
                        icon="el-icon-search"
                        @click="getUserList"
                    ></el-button>
                </el-input>
            </el-col>
            <el-col :span="4">
                <el-button type="primary" @click="dialogVisible = true">添加用户</el-button>
            </el-col>
        </el-row>

        <el-table 
        :data="userList"
        border
        stripe
        >
            <el-table-column 
            label="序号"
            width="80"
            type="index">
            </el-table-column>
            <el-table-column
                prop="username"
                label="姓名"
                width="100">
            </el-table-column>
            <el-table-column
                prop="email"
                label="邮箱"
                width="180">
            </el-table-column>
            <el-table-column
                prop="mobile"
                label="电话"
                width="180">
            </el-table-column>
            <el-table-column
                prop="role_name"
                label="角色"
                width="180">
            </el-table-column>
            <el-table-column
                prop=""
                label="状态"
                width="180">
                <template slot-scope="scope" prop="mg_state">
                    <el-switch
                        v-model="scope.row.mg_state"
                        @change="userStateChanged(scope.row)"
                        >
                    </el-switch>
                </template>
            </el-table-column>
            <el-table-column
                prop=""
                label="操作"
                width="200"
            >
                <template slot-scope="scope">
                    <!-- 修改按钮 -->
                    <el-tooltip 
                    class="item" 
                    effect="dark" 
                    content="修改" 
                    placement="bottom-start">
                        <el-button 
                        type="primary" 
                        icon="el-icon-edit" 
                        size="mini"
                        @click="showUserFrom(scope.row.id)"
                        ></el-button>
                    </el-tooltip>
                    <!-- 删除按钮 -->
                    <el-tooltip class="item" effect="dark" content="删除" placement="bottom">
                        <el-button 
                        type="danger" 
                        icon="el-icon-delete" 
                        size="mini"
                        @click="removeUser(scope.row.id)"
                        ></el-button>
                    </el-tooltip>
                    <!-- 角色分配按钮 -->
                    <el-tooltip class="item" effect="dark" content="分配角色" placement="bottom-end">
                        <el-button 
                        type="warning" 
                        icon="el-icon-help" 
                        size="mini"
                        @click="setRole(scope.row)"></el-button>
                    </el-tooltip>
                </template>
            </el-table-column>
        </el-table>

        <!-- 分页 -->
        <el-pagination
            @size-change="handleSizeChange"
            @current-change="handleCurrentChange"
            :current-page="queryInfo.pagenum"
            :page-sizes="[1, 2, 5, 10]"
            :page-size="queryInfo.pagesize"
            layout="total, sizes, prev, pager, next, jumper"
            :total="total"
            >
        </el-pagination>
    </el-card>
    <!-- 弹框组件 -->
    <el-dialog
        title="添加用户"
        :visible.sync="dialogVisible"
        width="50%"
        @close="closeDialog"
        >
            <el-form :model="ruleForm" :rules="rules" ref="ruleFormRef" label-width="80px">
                <el-form-item label="用户名" prop="username">
                    <el-input type="text" v-model="ruleForm.username"></el-input>
                </el-form-item>
                <el-form-item label="密码" prop="password">
                    <el-input type="password" v-model="ruleForm.password"></el-input>
                </el-form-item>
                <el-form-item label="邮箱" prop="email">
                    <el-input type="text" v-model="ruleForm.email"></el-input>
                </el-form-item>
                <el-form-item label="手机" prop="mobile">
                    <el-input type="text" v-model="ruleForm.mobile"></el-input>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="dialogVisible = false">取 消</el-button>
                <el-button type="primary" @click="addUser">确 定</el-button>
            </span>
    </el-dialog>
    
    <el-dialog
        title="修改用户信息"
        :visible.sync="userUpdateFrom"
        width="50%"
        @close="closeEditFrom"
        >
            <el-form :model="editFrom" :rules="editFromRules" ref="editFromRef" label-width="80px">
                <el-form-item label="用户名" prop="username">
                    <el-input type="text" v-model="editFrom.username" disabled></el-input>
                </el-form-item>
                <el-form-item label="邮箱" prop="email">
                    <el-input type="text" v-model="editFrom.email"></el-input>
                </el-form-item>
                <el-form-item label="手机" prop="mobile">
                    <el-input type="text" v-model="editFrom.mobile"></el-input>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="userUpdateFrom = false">取 消</el-button>
                <el-button type="primary" @click="editUser">确 定</el-button>
            </span>
    </el-dialog>

    <!-- 分配角色 -->
    <el-dialog
        title="分配角色"
        :visible.sync="setRoledialogVisible"
        width="50%"
        @close="setRoleDialongClosed"
        >
        <div>
            <p>当前用户:{{userInfo.username}}</p>
            <p>当前角色:{{userInfo.role_name}}</p>
            <p>分配新角色:
                <el-select v-model="selectedRoleId" placeholder="请选择">
                    <el-option
                        v-for="item in roleList"
                        :key="item.id"
                        :label="item.roleName"
                        :value="item.id">
                    </el-option>
                </el-select>
            </p>
        </div>
        <span slot="footer" class="dialog-footer">
            <el-button @click="setRoledialogVisible = false">取 消</el-button>
            <el-button type="primary" @click="saveRoleInfo">确 定</el-button>
        </span>
    </el-dialog>
  </div>
</template>

<script>
export default {
    data(){
        // 验证邮箱
        var checkEmail = (rule, val, callback) => {
            const regEmail = /^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,})$/
            if(regEmail.test(val)){
                return callback()
            } else {
                callback(new Error("请输入合法邮箱"))
            }
        }
        // 验证手机号
        var checkPhone = (rule, val, callback) => {
            const regPhone = /^(13[0-9]|14[01456879]|15[0-35-9]|16[2567]|17[0-8]|18[0-9]|19[0-35-9])\d{8}$/
            if(regPhone.test(val)){
                return callback()
            } else {
                callback(new Error("请输入合法手机号"))
            }
        }
        return{
            // 获取用户列表参数对象
            queryInfo: {
                query: '',
                pagenum: 1,
                pagesize: 2
            },
            editFrom: {},
            userList: [],
            total: 0,
            dialogVisible: false,
            userUpdateFrom: false,
            ruleForm: {
                username: '',
                password: '',
                email: '',
                mobile: ''
            },
            rules: {
                username: [
                    { required: true, message: '请输入用户名', trigger: 'blur' },
                    { min: 3, max: 5, message: '长度在 3 到 5 个字符', trigger: 'blur' }
                ],
                password: [
                    { required: true, message: '请输入密码', trigger: 'blur' },
                    { min: 3, max: 5, message: '长度在 3 到 5 个字符', trigger: 'blur' }
                ],
                email: [
                    { required: true, message: '请输入邮箱', trigger: 'blur' },
                    { validator: checkEmail, trigger: 'blur' }
                ],
                mobile: [
                    { required: true, message: '请输入手机号', trigger: 'blur' },
                    { validator: checkPhone, trigger: 'blur' }
                ]
            },
            editFromRules: {
                email: [
                    { required: true, message: '请输入邮箱', trigger: 'blur' },
                    { validator: checkEmail, trigger: 'blur' }
                ],
                mobile: [
                    { required: true, message: '请输入手机号', trigger: 'blur' },
                    { validator: checkPhone, trigger: 'blur' }
                ]
            },
            setRoledialogVisible: false,
            //需要被分配角色的用户信息
            userInfo: {},
            //所有角色数据列表
            roleList: '',
            value: '',
            selectedRoleId: ''
        }
    },
    created(){
        this.getUserList()
    },
    methods:{
        async getUserList(){
           const {data:res} = await this.$http.get('users', {params: this.queryInfo})
           // console.log(res);
           if(res.meta.status !== 200 ) return this.$message.error("获取用户列表失败");
            this.userList = res.data.users
            this.total = res.data.total
        },
        // 监听分页数据
        handleSizeChange(newSzie){
            // console.log(newSzie);
            this.queryInfo.pagesize = newSzie
            this.getUserList()
        },
        // 监听页码只改变事件
        handleCurrentChange(newPage){
            // console.log(newPage);
            this.queryInfo.pagenum = newPage
            this.getUserList()
        },
        async userStateChanged(val){
            // console.log(val);
            const { data:res} = await this.$http.put(`users/${val.id}/state/${val.mg_state}`);
            if(res.meta.status !== 200 ) {
                val.mg_state = !val.mg_state
                return this.$message.error("更新用户状态失败")
            } else {
                this.$message.success("更新成功")
            }
        },
        // 监听关闭创建用户对话框
        closeDialog(){
            this.$refs.ruleFormRef.resetFields()
            
        },
        // 添加用户表单预校验
        addUser(){
            this.$refs.ruleFormRef.validate(async val => {
                console.log(val);
                if(!val) return
                // 验证通过,开始添加请求
                const {data: res} = await this.$http.post('users', this.ruleForm)
                console.log(res);
                if(res.meta.status !==201 ) return this.$message.error("添加用户失败")
                this.$message.success("添加用户成功")
                this.dialogVisible = false
                this.getUserList()
            })
        },
        async showUserFrom(id){
            this.userUpdateFrom = true
            const {data:res} = await this.$http.get('users/' + id )
            console.log(res);
            if(res.meta.status !== 200) return this.$message.error("用户信息获取失败")
            console.log(res);
            this.editFrom = res.data

        },
        // 修改用户信息校验
        editUser(){
            this.$refs.editFromRef.validate(async val => {
                console.log(val);
                if(!val) return
                // 验证通过,开始添加请求
                const {data:res} = await this.$http.put('users/' + this.editFrom.id , this.editFrom)
                if(res.meta.status !== 200) return this.$message.error("请求失败")
                this.$message.success("用户信息修改成功")
                this.userUpdateFrom = false
                this.getUserList()

            })
        },
        closeEditFrom(){
            this.$refs.editFromRef.resetFields()
        },
        // 根据id删除用户
        async removeUser(id){
            const res = await this.$confirm(
                "确定要删除用户吗?", 
                '提示', 
                {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
                },
                console.log(res)
            ).catch( err => err)  //省略return需要省略{}
            
            // confirm确认   cancle取消
            if(res !== "confirm") {
                return this.$message.info("已取消删除")
            } else {
                const {data:delUser} = await this.$http.delete('users/' + id)
                if(delUser.meta.status !== 200) return this.$message.error("删除失败")
                this.$message.success("删除成功")
                this.getUserList()
            }
        },
        async setRole(userInfo){
            this.userInfo = userInfo

            // 在展示对话框之前，获取所有角色列表
            const {data:res} =await this.$http.get("roles")
            // console.log(res);
            if(res.meta.status !== 200) return this.$message.error("获取失败")
            this.roleList = res.data
            this.setRoledialogVisible = true
        },
        async saveRoleInfo() {
            if(!this.selectedRoleId){
                return this.$message.error("请选择要分配的角色")
            } else {
                const {data:res} = await this.$http.put(`users/${this.userInfo.id}/role`, {rid: this.selectedRoleId})
                console.log(res);
                if(res.meta.status !== 200) return this.$message.error("分配角色失败")
                this.$message.success("角色分配成功")
                this.getUserList()
                this.setRoledialogVisible = false
            }
        },
        // 监听分配角色对话框关闭事件
        setRoleDialongClosed() {
            this.selectedRoleId = '',
            this.userInfo = ''
        }
    }
}
</script>

<style scoped>

</style>